# NOTE: Derived from lib/Zoidberg/Fish/Log.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Zoidberg::Fish::Log;

#line 167 "lib/Zoidberg/Fish/Log.pm (autosplit into blib/lib/auto/Zoidberg/Fish/Log/fc.al)"
Command to manipulate the history.

Note that the selection of the editor is not POSIX compliant
but follows bash, if no editor is given using the '-e' option
the environment variables 'FCEDIT' and 'EDITOR' are both checked,
if neither is set, B<vi> is used.
( According to POSIX we should use 'ed' by default and ignore
the 'EDITOR' varaiable. )


sub fc {
	my $self = shift;
	my ($opt, $args) = getopt 'reverse,r editor,e$ list,l n s @', @_;
	my @replace = split('=', shift(@$args), 2) if $$args[0] =~ /=/;
	error 'usage: fc [options] [old=new] [first [last]]' if @$args > 2;
	
	# get selection
	# TODO -number +number .. needs getopt features
	my ($first, $last) = @$argv;
	if (!$first) { ($first,$last) = $$opt{s} ? (-1, -1) : (-16, -1) }
	elsif (!$last) { $last = -1 }
	# FIXME how to get _our_ hist, not our brothers ?

	if ($$opt{list}) { # list history
		output $$opt{n}
			? [ map @lines ]
			: [ map @lines ] ;
		return;
	}
	
	unless ($$opt{s}) {
		# edit history - editor behaviour consistent with T:RL:Z
		my $editor = $$opt{editor} || $ENV{FCEDIT} || $ENV{EDITOR} || 'vi';
		eval 'require File::Temp' || error 'need File::Temp from CPAN';
		($fh, $file) = File::Temp::tempfile(
			'Zoid_fc_XXXXX', DIR => File::Spec->tmpdir );
		print {$fh} @lines;
		# unless editor error
		# insert new command in history
		#  TODO remove self from history ... posix says so
		# shell new command
		#  TODO inherit environment and redirection from self
	}
}

1;
# end of Zoidberg::Fish::Log::fc
